<template>
  <BaseModal :show="true">
    <div class="modal">
      <h2 class="uppercase fs-800">{{ titleText }}</h2>
      <div class="content">
        <BaseIcon width="64px" height="64px" :iconName="icon" :color="color" />
        <p class="uppercase fs-900" :class="className">{{ resultText }}</p>
      </div>
      <div class="buttons">
        <BaseButton class="uppercase bg-silver btn-quit" @click="quit">
          Quit
        </BaseButton>
        <BaseButton
          class="uppercase bg-light-yellow btn-next"
          @click="nextRound"
          >Next round
        </BaseButton>
      </div>
    </div>
  </BaseModal>
</template>

<script>
import BaseButton from "./ui/BaseButton.vue";
import { computed, toRefs } from "vue";
import winner from "@/config/winner";
/* eslint-disable */

export default {
  components: { BaseButton },
  name: "GameResult",
  emits: ["quit", "nextRound"],
  props: {
    result: {
      default: 0,
    },
    choice: {
      default: 0,
    },
  },
  setup(props, { emit }) {
    const { result, choice } = toRefs(props);
    const icon = computed(function () {
      if (result.value == winner.TIIED) {
        return "";
      }
      return result.value == winner.X_WIN ? "xTurnIcon" : "oTurnIcon";
    });
    const className = computed(function () {
      if (result.value == winner.TIIED) {
        return "";
      }
      return result.value == winner.X_WIN
        ? "text-light-blue"
        : "text-light-yellow";
    });
    const titleText = computed(function () {
      if (result.value == winner.TIIED) {
        return "";
      }
      return result.value == choice.value ? "you win" : "oh no, you lost";
    });
    const resultText = computed(function () {
      if (result.value == winner.TIIED) {
        return "round tied";
      }
      return "takes the round";
    });
    const color = computed(function () {
      if (result.value == winner.TIIED) {
        return "";
      }
      return result.value == winner.X_WIN ? "#31C3BD" : "#F2B137";
    });

    function quit() {
      emit("quit");
    }
    function nextRound() {
      emit("nextRound");
    }

    return { quit, nextRound, color, icon, className, titleText, resultText };
  },
};
</script>

<style lang="scss" scoped>
.modal {
  display: grid;
  gap: 1rem;
  .content {
    display: flex;
    justify-content: center;
    align-items: center;
    gap: 2rem;
    font-weight: bold;
  }
  .buttons {
    display: flex;
    justify-content: center;
    align-items: center;
    gap: 1rem;
    .btn-next {
      box-shadow: inset 0 -4px 0 #cc8b13;
      &:hover {
        background: var(--clr-light-yellow-hover);
      }
    }
    .btn-quit {
      box-shadow: inset 0 -4px 0 #6b8997;
      &:hover {
        background: var(--clr-silver-hover);
      }
    }
  }
}
</style>
